﻿Imports IrcDotNet
Imports IrcDotNet.Ctcp
Imports System.Drawing
Imports Wisej.Web
Imports System.Threading
Imports System.Threading.Tasks
Public Class ChatWindow
    Dim isSorting As Boolean

    Dim ircserver As String = "chat1.ustream.tv"
    Dim port As Integer
    Dim MainChannel As String = "#the-ed-morrissey-show"
    Dim anonprefix As String = "VWG-"
    Dim BaseURL As String = ""

    Dim COTxtColor As Color = Color.Red
    Dim OpTxtColor As Color = Color.Blue
    Dim HOTxtColor As Color = Color.Blue
    Dim NormTxtColor As Color = Color.Black
    Dim ErrorTxtColor As Color = Color.DarkRed
    Dim Actiontxtcolor As Color = Color.Purple
    Dim COtxtFont As Font
    Dim OptxtFont As Font
    Dim HOTxtFont As Font
    Dim NormtxtFont As Font
    Dim ErrortxtFont As Font
    Dim BoldNickTime As Boolean = True
    Dim NickPrefix As String = ""
    Dim NickPostfix As String = ""
    Dim ShowTime As Boolean = True
    Dim ChatMainStartSize As Single
    Dim ChatMainPrefix As String = ""
    Dim ChatMainPostfix As String = ""
    'Dim SmileyList As New List(Of SmileyImg)
    Dim timeouter As Integer = 0
    Dim chathasfocus As Boolean = False
    Dim datediff As TimeSpan = New TimeSpan

    Dim myserver As IrcServer
    Dim clientconn As StandardIrcClient
    Dim ctcpclient1 As CtcpClient

    Dim collectedurls As New List(Of String)
    Dim ChanList As New List(Of ChatChannel)
    Dim ChanLbls As New List(Of Label)
    Dim CurChan As New ChatChannel
    Dim relogin As Boolean
    Dim ri As New IrcUserRegistrationInfo
    Dim isloading As Boolean = True
    Dim incominglog As New List(Of IrcRawMessageEventArgs)
    Private Class HtmlMessage
        Public msgtxt As String
        Public msgfont As Font
        Public formatmsgtxt As String
        Public Sub New()
            msgtxt = ""
            formatmsgtxt = ""
        End Sub
    End Class

    Private Sub ChatWindow_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        'setup for application closing and getting client time
        'AddHandler Application.ThreadSuspend, AddressOf Application_ThreadSuspend
        'Dim LDC As LDC = New LDC
        'LDC.GetClientDate(AddressOf callbackGetClientDate)
        'ChatSplitter.BackColor = Color.Black
        ''Sets WebSocket's handler class
        'Application.WebSockets.SetHandler(Of ChatForm.ChatWebSocketsHandler)()
        ''Tries to cast WebSocketHandler as CompanionKitWebSocketsHandler
        'Dim objHandler As ChatForm.ChatWebSocketsHandler = TryCast(Application.WebSockets.WebSocketHandler, ChatForm.ChatWebSocketsHandler)
        'If objHandler IsNot Nothing Then
        '    'Sets current instance to Page property
        '    objHandler.Page = Me
        'End If

        'retrieve properties from web config
        Dim appval As String = ""
        appval = System.Configuration.ConfigurationSettings.AppSettings("ircserver").ToString()
        If appval = "" Then
            ircserver = "chat1.ustream.tv"
        Else
            ircserver = appval
        End If
        appval = System.Configuration.ConfigurationSettings.AppSettings("port").ToString()
        If appval = "" Then
            port = "6667"
        Else
            port = appval
        End If
        appval = System.Configuration.ConfigurationSettings.AppSettings("channel").ToString()
        If appval = "" Then
            MainChannel = "#the-ed-morrissey-show"
        Else
            MainChannel = appval
        End If
        appval = System.Configuration.ConfigurationSettings.AppSettings("anonprefix").ToString()
        If appval = "" Then
            anonprefix = "VWG-"
        Else
            anonprefix = appval
        End If

        COtxtFont = New Font("Arial", 9, FontStyle.Regular, GraphicsUnit.Point)
        OptxtFont = New Font("Arial", 9, FontStyle.Regular, GraphicsUnit.Point)
        HOTxtFont = New Font("Arial", 9, FontStyle.Regular, GraphicsUnit.Point)
        NormtxtFont = New Font("Arial", 9, FontStyle.Regular, GraphicsUnit.Point)
        ErrortxtFont = New Font("Arial", 9, FontStyle.Regular, GraphicsUnit.Point)

        Dim i As Integer = 1
        'load smileys
        Dim found As Boolean = True
        'Do While found
        '    Try
        '        appval = System.Configuration.ConfigurationSettings.AppSettings("smiley" & i).ToString()
        '        SmileyList.Add(New SmileyImg(appval))

        '        found = True
        '    Catch ex As Exception
        '        'no more smileys
        '        found = False
        '    End Try
        '    i += 1
        'Loop

        ''setup chat and nick grid
        ''ChatMainStartSize = ChatMain2.Height
        'Dim imgcolumn As New DataGridViewImageColumn
        'Dim objcolumn As New DataGridViewColumn
        'NickGrid.Columns.Add(imgcolumn)
        'NickGrid.Columns(0).Width = 45
        'NickGrid.Columns.Add("Nicks", "NickList")
        'NickGrid.Columns.Add("UnformattedNicks", "")
        'NickGrid.Columns(2).Visible = False
        'NickGrid.ColumnHeadersVisible = False
        'NickGrid.SelectionMode = DataGridViewSelectionMode.FullRowSelect
        'BaseURL = GetASPNETBaseURL()

        'configure initial login and connect to IRC server

        ri.UserName = "Lotd2242" 'anonprefix & RandomNumber(9999, 1000)
        ri.NickName = "Lotd2242" 'ri.UserName
        ri.RealName = "ChatasaurUser"
        ri.Password = "vvercavv"
        AddMsgtoChannel(CurChan, FormatText("Ready to connect...", "", ErrortxtFont, ErrorTxtColor, False))
        found = True
        i = 1
        Do While found
            Try
                appval = System.Configuration.ConfigurationSettings.AppSettings("intromessage" & i).ToString()
                If appval <> "" Then
                    AddMsgtoChannel(CurChan, FormatText(appval, "", ErrortxtFont, ErrorTxtColor, False))
                End If

                found = True
            Catch ex As Exception
                'no more smileys
                found = False
            End Try
            i += 1
        Loop
        CreateConnection()

        'Dim autologin As Boolean
        'appval = System.Configuration.ConfigurationSettings.AppSettings("autologin").ToString()
        'If appval <> "" Then
        '    autologin = appval
        'Else
        '    autologin = True
        'End If
        'If autologin Then

        clientconn.Connect(ircserver, port, False, ri)

        'End If

    End Sub

#Region "ClientConnectionHandlers"
    Private Sub CreateConnection()
        clientconn = New StandardIrcClient
        AddHandler clientconn.Connected, AddressOf ClientConnected
        AddHandler clientconn.Registered, AddressOf ClientRegistered
        AddHandler clientconn.Disconnected, AddressOf ClientDisconnected
        AddHandler clientconn.ProtocolError, AddressOf ClientProtocolError
        AddHandler clientconn.ErrorMessageReceived, AddressOf ircClient1_ErrorMessageReceived
        AddHandler clientconn.ConnectFailed, AddressOf ircClient1_ConnectionFail
        AddHandler clientconn.Error, AddressOf ircClient1_ConnectionFail
        AddHandler clientconn.RawMessageReceived, AddressOf ircClient1_RawMessageReceived
    End Sub
    Private Sub ClientConnected(ByVal sender As Object, ByVal e As System.EventArgs)
        'only demonstrates socket connection
        'want to stick to Client Registered to ensure connection to nickserver
    End Sub
    Private Sub ClientDisconnected(ByVal sender As Object, ByVal e As System.EventArgs)

        AddMsgtoChannel(CurChan, FormatText("You have been disconnected from the server.", "", ErrortxtFont, ErrorTxtColor, False))
        'If LoginBtn.Text = "Log Out" Then
        '    UNameLbl.Text = "Username:"
        '    PwdLbl.Text = "Password:"
        '    BtnsPnl.Left = PwdTxt.Right + 6
        '    UNameLbl.Width = UNameTxt.Width
        '    UNameTxt.Visible = True
        '    PwdTxt.Visible = True
        '    PwdLbl.Visible = True
        '    LoginBtn.Text = "Log In"
        '    If ChanList.Count > 0 Then
        '        CloseAllChannels()
        '    End If

        'End If
    End Sub
    Private Sub ClientProtocolError(ByVal sender As Object, ByVal e As IrcProtocolErrorEventArgs)
        'handles stuff like needing to be voiced
        If e.Code = "404" Then
            AddMsgtoChannel(CurChan, FormatText("You do not have permission to speak in the channel. Please log in or ask your moderator to give you voice.", "", ErrortxtFont, ErrorTxtColor, False))
        Else
            AddMsgtoChannel(CurChan, FormatText(e.Message, "", ErrortxtFont, ErrorTxtColor, False))
        End If

    End Sub
    Private Sub ClientRegistered(ByVal sender As Object, ByVal e As System.EventArgs)
        AddHandler clientconn.LocalUser.ModesChanged, AddressOf ircClient1_LocalUser_ModesChanged
        AddHandler clientconn.LocalUser.NickNameChanged, AddressOf ircClient1_LocalUser_NickNameChanged
        AddHandler clientconn.LocalUser.IsAwayChanged, AddressOf ircClient1_LocalUser_IsAwayChanged
        AddHandler clientconn.LocalUser.JoinedChannel, AddressOf ircClient1_LocalUser_JoinedChannel
        AddHandler clientconn.LocalUser.LeftChannel, AddressOf ircClient1_LocalUser_LeftChannel
        AddHandler clientconn.LocalUser.MessageSent, AddressOf ircClient1_LocalUser_MessageSent
        AddHandler clientconn.LocalUser.NoticeSent, AddressOf ircClient1_LocalUser_NoticeSent
        AddHandler clientconn.LocalUser.MessageReceived, AddressOf ircClient1_LocalUser_MessageReceived
        AddHandler clientconn.LocalUser.NoticeReceived, AddressOf ircClient1_LocalUser_NoticeReceived

        AddMsgtoChannel(CurChan, FormatText("Joining channel...", "", ErrortxtFont, ErrorTxtColor, False))
        clientconn.Channels.Join(MainChannel)
        'If clientconn.LocalUser.NickName.IndexOf("VWG") = -1 Then
        '    AddMsgtoChannel(CurChan, FormatText("You are now logged in as " & clientconn.LocalUser.NickName, "", ErrortxtFont, ErrorTxtColor, False))
        '    UNameLbl.Text = "You are logged in as: " & clientconn.LocalUser.NickName
        '    UNameLbl.Width = UNameTxt.Left + UNameTxt.Width + BtnsPnl.Width
        '    'PwdLbl.Text = e.NewNick
        '    UNameTxt.Visible = False
        '    PwdTxt.Visible = False
        '    PwdLbl.Visible = False
        '    BtnsPnl.Left = UNameTxt.Left
        '    LoginBtn.Text = "Log Out"
        'End If

        'relogin = False
        'clientconn.LocalUser.SendMessage("#the-ed-morrissey-show /me", "wonder twin powers activate!")
        'clientconn.SendRawMessage("#the-ed-morrissey-show /me wonder twin powers activate!")


    End Sub
    Private Sub ircClient1_ConnectionFail(ByVal sender As Object, ByVal e As IrcErrorEventArgs)
        AddMsgtoChannel(CurChan, FormatText("Connection to server was unsucessful. " & e.Error.Message, "", ErrortxtFont, ErrorTxtColor, False))
    End Sub
#End Region
#Region "LocalUserHandlers"

    Private Sub ircClient1_LocalUser_ModesChanged(ByVal sender As Object, ByVal e As EventArgs)
        'If Not IsNothing(CurChan) Then
        '    If sender.GetType Is GetType(IrcChannel) Then
        '        If sender.channelname = CurChan.ChannelName Then
        '            FillNickList()
        '        End If
        '    End If
        'End If

    End Sub
    Private Sub ircClient1_LocalUser_NickNameChanged(ByVal sender As Object, ByVal e As EventArgs)
        'If client1LocalUserNickNameChangedEvent IsNot Nothing Then
        '    client1LocalUserNickNameChangedEvent.[Set]()
        'End If
        If Not IsNothing(CurChan) Then
            'Catching this in the raw event
            'SwapNicksinList(sender.username, sender.nickname)

        End If


    End Sub
    Private Sub ircClient1_LocalUser_IsAwayChanged(ByVal sender As Object, ByVal e As EventArgs)
        ''If client1LocalUserIsAwayChangedEvent IsNot Nothing Then
        ''    client1LocalUserIsAwayChangedEvent.[Set]()
        ''End If
        'FillNickList()
    End Sub
    Private Sub ircClient1_LocalUser_JoinedChannel(ByVal sender As Object, ByVal e As IrcChannelEventArgs)

        Dim newchan As New ChatChannel
        newchan.ChannelName = e.Channel.Name
        newchan.Channel = e.Channel

        AddHandler newchan.ChannelUserListReceived, AddressOf Channel_UsersListReceived
        AddHandler newchan.ChannelModesChanged, AddressOf Channel_ModesChanged
        AddHandler newchan.ChannelTopicChanged, AddressOf Channel_TopicChanged
        AddHandler newchan.ChannelUserJoined, AddressOf Channel_UserJoined
        AddHandler newchan.ChannelUserLeft, AddressOf Channel_UserLeft
        AddHandler newchan.ChannelUserKicked, AddressOf Channel_UserKicked
        AddHandler newchan.ChannelMessageReceived, AddressOf Channel_MessageReceived
        AddHandler newchan.ChannelNoticeReceived, AddressOf Channel_NoticeReceived


        If ChanList.Count = 0 Then
            newchan.ChannelHeight = CurChan.ChannelHeight
            newchan.FormattedMessageLog = CurChan.FormattedMessageLog
            newchan.MessageLog = CurChan.MessageLog
        End If
        'CurChan = newchan
        ChanList.Add(newchan)
        AddNewChanLbl(newchan.ChannelName)
        OpenChannel(newchan)
        If newchan.ChannelName.IndexOf("#") <> -1 Then
            AddMsgtoChannel(newchan, FormatText("Joined channel " & newchan.Channel.Name, "", ErrortxtFont, ErrorTxtColor, False))
        End If


        'If client1ChannelJoinedEvent IsNot Nothing Then
        '    client1ChannelJoinedEvent.[Set]()
        'End If
        'Label1.Text = "Joined TEMS"
    End Sub
    Private Sub ircClient1_LocalUser_LeftChannel(ByVal sender As Object, ByVal e As IrcChannelEventArgs)
        Dim oldchan As ChatChannel
        oldchan = GetChannel(e.Channel.Name)
        CloseChannel(oldchan)

        'client1ChannelLeaveComment = e.Comment

        'If client1ChannelLeftEvent IsNot Nothing Then
        '    client1ChannelLeftEvent.[Set]()
        'End If
    End Sub
    Private Sub ircClient1_LocalUser_MessageSent(ByVal sender As Object, ByVal e As IrcMessageEventArgs)
        'If client1LocalUserMessageSentEvent IsNot Nothing Then
        '    client1LocalUserMessageSentEvent.[Set]()
        'End If
    End Sub
    Private Sub ircClient1_LocalUser_NoticeSent(ByVal sender As Object, ByVal e As IrcMessageEventArgs)
        'If client1LocalUserNoticeSentEvent IsNot Nothing Then
        '    client1LocalUserNoticeSentEvent.[Set]()
        'End If
    End Sub
    Private Sub ircClient1_LocalUser_MessageReceived(ByVal sender As Object, ByVal e As IrcMessageEventArgs)
        Dim querychan As New ChatChannel
        querychan = GetChannel(e.Source.Name)
        If IsNothing(querychan) Then
            querychan = CreateNewQueryChannel(e.Source.Name, "Started private chat with " & e.Source.Name, "Private chat with " & e.Source.Name)
            OpenChannel(querychan)
        End If
        AddMsgtoChannel(querychan, FormatMessage(querychan, e.Source, e.Text))
        'SendUpdateNotice("updatechat", "")
    End Sub
    Private Sub ircClient1_ErrorMessageReceived(ByVal sender As Object, ByVal e As IrcErrorMessageEventArgs)
        AddMsgtoChannel(CurChan, FormatText(e.Message, "", ErrortxtFont, ErrorTxtColor, False))
    End Sub
    Private Sub ircClient1_RawMessageReceived(ByVal sender As Object, ByVal e As IrcRawMessageEventArgs)
        'ircchannel does not have a nick changed event, so have to catch that here
        'nor a ban event
        'nor a quit event
        Dim j As Integer
        Dim user As IrcUser

        incominglog.Add(e) 'used for debugging purposes

        If e.Message.Command = "BAN" Then
            user = DirectCast(e.Message.Source, IrcDotNet.IrcUser)
            Dim reason As String = ""
            If Not IsNothing(e.Message.Parameters(2)) Then
                reason = e.Message.Parameters(2)
            End If
            For j = 0 To user.Client.Channels.Count - 1
                Channel_UserBanned(user.Client.Channels(j), user, reason)
            Next
        ElseIf e.Message.Command = "QUIT" Then
            user = DirectCast(e.Message.Source, IrcDotNet.IrcUser)
            For j = 0 To user.Client.Channels.Count - 1
                Channel_UserQuit(user.Client.Channels(j), user)
            Next
        ElseIf e.Message.Command = "MODE" Then
            'Channel_ModesChanged is great, except it doesn't say what changed
            If Not IsNothing(e.Message.Parameters(0)) Then
                Dim chan As ChatChannel = GetChannel(e.Message.Parameters(0))
                If Not IsNothing(chan) Then
                    'mode switch from channel

                    If Not IsNothing(e.Message.Parameters(2)) Then
                        If e.Message.Parameters(2) <> "" And e.Message.Parameters(2).IndexOf("#") = -1 Then
                            'person mode change
                            Channel_NewUserMode(chan, e.Message.Parameters(2), e.Message.Parameters(1))
                        Else
                            'chan mode change
                            NewChannelMode(chan, e.Message.Parameters(1))
                        End If

                    Else
                        NewChannelMode(chan, e.Message.Parameters(1))
                    End If
                End If
            End If


        ElseIf e.Message.Command = "NICK" Then
            user = DirectCast(e.Message.Source, IrcDotNet.IrcUser)
            For j = 0 To user.Client.Channels.Count - 1
                Channel_UserReNick(user.Client.Channels(j), user, e.Message.Parameters(0))
            Next


        ElseIf e.Message.Command = "NOTICE" Then
            'notice does not go to localuser until registration
            'so if not registered, probably an error with username/pwd
            If Not clientconn.IsRegistered Then
                AddMsgtoChannel(CurChan, FormatText(e.Message.Parameters(1), "", ErrortxtFont, ErrorTxtColor, False))
            End If


        End If


    End Sub
    Private Sub ircClient1_LocalUser_NoticeReceived(ByVal sender As Object, ByVal e As IrcMessageEventArgs)
        AddMsgtoChannel(CurChan, FormatText(e.Text, e.Source.Name, ErrortxtFont, ErrorTxtColor, False))
    End Sub

#End Region
#Region "ChannelHandlers"
    Private Function GetChannel(ByVal channelname As String) As ChatChannel
        For Each chan As ChatChannel In ChanList
            If chan.ChannelName = channelname Then
                Return chan
            End If
        Next
        Return Nothing
    End Function
    Private Function CreateNewQueryChannel(ByVal channelname As String, ByVal intromessage As String, ByVal introtopic As String) As ChatChannel
        Dim querychan As New ChatChannel
        querychan.ChannelName = channelname
        querychan.ChannelTopic = introtopic
        Dim htmlmsg As HtmlMessage = FormatText(intromessage, "", ErrortxtFont, ErrorTxtColor, False)
        querychan.FormattedMessageLog = htmlmsg.formatmsgtxt
        querychan.MessageLog = htmlmsg.msgtxt
        ChanList.Add(querychan)
        AddNewChanLbl(querychan.ChannelName)
        Return querychan

    End Function
    Private Sub OpenChannel(ByVal Channel As ChatChannel)
        CurChan = Channel
        'If Channel.ChannelName.IndexOf("#", 0, 1) <> -1 Then
        '    'is channel
        '    FillNickList()
        '    NickGrid.Visible = True
        '    ChanCloseBtn.Visible = False
        '    'ChatWinPnl.Width = NickGrid.Left - ChatWinPnl.Left - 2
        '    ChatSplitter.Panel2Collapsed = False
        'Else
        '    'is query
        '    NickGrid.Visible = False
        '    ChatSplitter.Panel2Collapsed = True
        '    ChanCloseBtn.Top = 0
        '    'ChatWinPnl.Width = NickGrid.Right - ChatWinPnl.Left
        '    'ChanCloseBtn.Left = ChatWinPnl.Right - ChanCloseBtn.Width - 25
        '    'ChanCloseBtn.Top = ChatMain2.Top
        '    ChanCloseBtn.Visible = True
        'End If
        ''ChatMain2.Width = ChatWinPnl.Width - 25
        ''ChatSpacerLbl.Width = ChatMain2.Width
        'TopicLbl.Text = CurChan.ChannelTopic
        ''ChatMain2.Html = ChatMainPrefix & Channel.FormattedMessageLog & ChatMainPostfix
        ''UpdateHTMLBox(CurChan)
        ASChatMain.Html = CurChan.FormattedMessageLog
        'SendUpdateNotice("query", CurChan.ChannelName)
    End Sub
    Private Sub CloseAllChannels()
        If ChanLbls.Count > 0 Then
            CurChan.ChannelName = ChanLbls(0).Text
        End If

        For i = ChanList.Count - 1 To 0 Step -1
            If Not IsNothing(ChanList(i).Channel) Then
                'not a query
                ChanList(i).Channel.Leave()
            End If

            CloseChannel(ChanList(i))
        Next
    End Sub
    Private Sub CloseChannel(ByVal Channel As ChatChannel)
        If Not IsNothing(Channel) Then
            Channel.RemoveHandlers()
            RemoveHandler Channel.ChannelUserListReceived, AddressOf Channel_UsersListReceived
            RemoveHandler Channel.ChannelModesChanged, AddressOf Channel_ModesChanged
            RemoveHandler Channel.ChannelTopicChanged, AddressOf Channel_TopicChanged
            RemoveHandler Channel.ChannelUserJoined, AddressOf Channel_UserJoined
            RemoveHandler Channel.ChannelUserLeft, AddressOf Channel_UserLeft
            RemoveHandler Channel.ChannelUserKicked, AddressOf Channel_UserKicked
            RemoveHandler Channel.ChannelMessageReceived, AddressOf Channel_MessageReceived
            RemoveHandler Channel.ChannelNoticeReceived, AddressOf Channel_NoticeReceived
            Dim chanind As Integer = ChanList.IndexOf(Channel)
            'Dim j As Integer
            'For j = chanind To ChanLbls.Count - 2
            '    ChanLbls(j).Text = ChanLbls(j + 1).Text
            '    ChanLbls(j).VisualEffect = ChanLbls(j + 1).VisualEffect
            '    ChanLbls(j).ForeColor = ChanLbls(j + 1).ForeColor
            '    ChanLbls(j).BorderColor = ChanLbls(j + 1).BorderColor
            '    ChanLbls(j).BorderStyle = ChanLbls(j + 1).BorderStyle
            '    ChanLbls(j).BorderWidth = ChanLbls(j + 1).BorderWidth
            'Next
            'Dim lbltogo As Label = ChanLbls(ChanLbls.Count - 1)
            'ChanLbls.Remove(lbltogo)
            'ChannelPnl.Controls.Remove(lbltogo)
            'Me.Controls.Remove(lbltogo)
            'lbltogo.Dispose()
            ChanList.Remove(Channel)
            If ChanList.Count > 0 Then
                OpenChannel(ChanList(0))
            End If
            'SendUpdateNotice("query", "")
        End If

    End Sub
    Private Sub AddNewChanLbl(ByVal ChannelName As String)
        'Dim newlbl As New Label
        'AddHandler newlbl.Click, AddressOf ChanLbl_Click
        'newlbl.Height = ChatLblPH.Height
        'newlbl.Width = GetTextWidth("W" & ChannelName & "W", newlbl.Font, 0, False)
        'If newlbl.Width > ChatLblPH.Width Then
        '    newlbl.Width = ChatLblPH.Width
        'End If
        'newlbl.Font = ChatLblPH.Font
        'newlbl.VisualEffect = ChatLblPH.VisualEffect
        'newlbl.ForeColor = ChatLblPH.ForeColor
        'newlbl.BorderColor = ChatLblPH.BorderColor
        'newlbl.BorderStyle = ChatLblPH.BorderStyle
        'newlbl.BorderWidth = ChatLblPH.BorderWidth
        'newlbl.Text = ChannelName
        'newlbl.TextAlign = ChatLblPH.TextAlign
        'newlbl.Cursor = Cursors.Hand
        'If ChanLbls.Count = 0 Then
        '    newlbl.Location = ChatLblPH.Location
        'Else
        '    newlbl.Top = ChanLbls(ChanLbls.Count - 1).Top
        '    newlbl.Left = ChanLbls(ChanLbls.Count - 1).Right + 6
        'End If

        'ChanLbls.Add(newlbl)
        'Me.Controls.Add(newlbl)
        'ChannelPnl.Controls.Add(newlbl)
    End Sub
    Private Sub ChanLbl_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        'If sender.text <> CurChan.ChannelName Then
        '    CurChan = GetChannel(sender.text)
        '    OpenChannel(CurChan)
        '    sender.backcolor = ChatLblPH.BackColor
        '    sender.borderstyle = ChatLblPH.BorderStyle
        '    sender.forecolor = Color.White
        '    sender.VisualEffect = ChatLblPH.VisualEffect
        'End If

    End Sub
    Private Sub Channel_UsersListReceived(ByVal sender As Object, ByVal e As System.EventArgs)
        'If sender Is CurChan Then
        '    FillNickList()
        'End If


    End Sub
    Private Sub Channel_ModesChanged(ByVal sender As Object, ByVal e As System.EventArgs)
        'not terribly useful since it contains no info as to what changed
        'but since nick mode changes happen here, we'll use it to update the nick list too
        If sender.channelname = CurChan.ChannelName Then
            'FillNickList()
        End If
    End Sub
    Private Sub NewChannelMode(ByVal Channel As ChatChannel, ByVal mode As String)

    End Sub
    Private Sub Channel_NewUserMode(ByVal Channel As ChatChannel, ByVal User As String, ByVal Mode As String)
        ''channel mode update will happen in modes changed
        'If Channel.ChannelName = CurChan.ChannelName Then
        '    'RemoveUserFromGrid(User)
        '    'AddUsertoList(User, Mode)
        '    If Mode.IndexOf("b") = -1 Then
        '        'don't need to catch ban list changes
        '        ChangeUserModeInList(User, Mode)
        '    End If

        'End If
    End Sub
    Private Sub Channel_TopicChanged(ByVal sender As Object, ByVal e As System.EventArgs)
        'If sender Is CurChan Then
        '    TopicLbl.Text = sender.channeltopic
        '    SendUpdateNotice("topic", sender.channeltopic)
        'End If

    End Sub
    Private Sub Channel_UserJoined(ByVal sender As Object, ByVal e As IrcChannelUserEventArgs)
        'If sender.channelname = CurChan.ChannelName Then
        '    AddUsertoList(e.ChannelUser)
        'End If
    End Sub
    Private Sub Channel_UserReNick(ByVal sender As Object, ByVal e As IrcUser, ByVal NewName As String)
        'If sender.name = CurChan.ChannelName Then
        '    SwapNicksinList(e.NickName, NewName)
        'End If

    End Sub
    Private Sub Channel_UserLeft(ByVal sender As Object, ByVal e As IrcChannelUserEventArgs)
        If sender.ChannelName = CurChan.ChannelName Then
            RemoveUserFromGrid(e.ChannelUser.User.NickName)
        End If

    End Sub
    Private Sub Channel_UserQuit(ByVal sender As Object, ByVal e As IrcUser)
        If sender.name = CurChan.ChannelName Then
            RemoveUserFromGrid(e.NickName)
        End If
    End Sub
    Private Sub Channel_UserKicked(ByVal sender As Object, ByVal e As IrcChannelUserEventArgs)
        If e.ChannelUser.User.NickName = clientconn.LocalUser.UserName Then
            AddMsgtoChannel(CurChan, FormatText("You have been kicked from the channel. Reason: " & e.Comment, "", ErrortxtFont, ErrorTxtColor, False))
        Else
            AddMsgtoChannel(CurChan, FormatText(e.ChannelUser.User.NickName & "has been kicked from the channel. Reason: " & e.Comment, "", ErrortxtFont, ErrorTxtColor, False))
        End If
        If sender Is CurChan Then
            RemoveUserFromGrid(e.ChannelUser.User.NickName)
        End If
    End Sub
    Private Sub Channel_UserBanned(ByVal sender As Object, ByVal e As IrcUser, ByVal Reason As String)
        'this sub is manual because there is no UserBanned method exposed for channels currently
        If e.NickName = clientconn.LocalUser.NickName Then
            AddMsgtoChannel(CurChan, FormatText("You have been kicked from the channel. Reason: " & Reason, "", ErrortxtFont, ErrorTxtColor, False))
        Else
            AddMsgtoChannel(CurChan, FormatText(e.NickName & "has been kicked from the channel. Reason: " & Reason, "", ErrortxtFont, ErrorTxtColor, False))
        End If
        If sender Is CurChan Then
            RemoveUserFromGrid(e.NickName)
        End If
    End Sub
    Private Sub RemoveUserFromGrid(ByVal UserName As String)
        'Dim userrow As Integer = -1
        'For j = 0 To NickGrid.Rows.Count - 1
        '    If NickGrid.Rows(j).Cells(2).Value = UserName Then
        '        userrow = j
        '        Exit For
        '    End If
        'Next
        'If userrow <> -1 Then
        '    NickGrid.Rows.RemoveAt(userrow)
        'End If
        'SendUpdateNotice("nickgrid", "")
    End Sub
    Private Sub Channel_MessageReceived(ByVal sender As Object, ByVal e As IrcMessageEventArgs)
        AddMsgtoChannel(sender, FormatMessage(sender, e.Source, e.Text))
    End Sub
    Private Sub Channel_NoticeReceived(ByVal sender As Object, ByVal e As IrcMessageEventArgs)

    End Sub
#End Region
    Private Sub AddMsgtoChannel(ByVal ChanneltoChange As ChatChannel, ByVal HMsg As HtmlMessage)
        ChanneltoChange.MessageLog &= vbNewLine & HMsg.msgtxt
        ChanneltoChange.FormattedMessageLog &= HMsg.formatmsgtxt

        If Not IsNothing(CurChan) Then

            If ChanneltoChange Is CurChan Then
                'update current channel text

                'SendUpdateNotice("addtochat", HMsg.formatmsgtxt)

                'If ASChatMain.Html.IndexOf("No Content") <> -1 Then
                '    ASChatMain.Html = ChanneltoChange.FormattedMessageLog
                'End If

                ASChatMain.Html = ChanneltoChange.FormattedMessageLog
                ASChatMain.Refresh()
                Me.Refresh()

                'ASChatMain.AddMsgtoChat("simple")
                'SendTexttoHTMLBox("simple")
                'AdjustHTMLBox(HMsg)
                'UpdateHTMLBox(ChanneltoChange)
            Else
                'bring other channel to foreground
                'For i = 0 To ChanLbls.Count - 1
                '    If ChanLbls(i).Text = ChanneltoChange.ChannelName Then
                '        ChanLbls(i).VisualEffect = ChatLblAltPH.VisualEffect
                '        'ChanLbls(i).ForeColor = Color.Red
                '        'Dim msg As New ChatForm.ChatSampleMessage("addtochat", HMsg.formatmsgtxt)
                '        SendUpdateNotice("chanlbl", ChanneltoChange.ChannelName)
                '    End If
                'Next
            End If
        End If
        Application.Update()

    End Sub
    Private Function FormatText(ByVal Text As String, ByVal Nick As String, ByVal FonttoUse As Font, ByVal ColortoUse As Color, ByVal IsAction As Boolean) As HtmlMessage
        'format message text into HTML string for HTML window
        Dim formattedstring As String = ""
        Dim newmsg As New HtmlMessage
        Dim boldpref As String = ""
        Dim boldpost As String = ""
        If BoldNickTime Then
            boldpref = "<b>"
            boldpost = "</b>"
        End If

        formattedstring = "<div style='font-size: " & FonttoUse.Size & "pt;line-height: 12px;vertical-align: middle; padding-right: 10px;'>"
        formattedstring &= "<font face='" & FonttoUse.Name & "'"
        formattedstring &= " color='" & System.Drawing.ColorTranslator.ToHtml(ColortoUse) & "'"
        formattedstring &= ">"


        '#the-ed-morrissey-show'</font>
        Dim clientdate As Date = Now - datediff
        If ShowTime Then
            newmsg.msgtxt &= "[" & FormatDateTime(clientdate, DateFormat.ShortTime) & "]  "
            formattedstring &= boldpref & "[" & FormatDateTime(clientdate, DateFormat.ShortTime) & "]  " & boldpost
        End If
        If IsAction Then
            formattedstring &= "<i> "
            formattedstring &= Nick
            formattedstring &= Text
            formattedstring &= "</i>"
            newmsg.msgtxt &= Nick & Text
            newmsg.msgfont = FonttoUse
            newmsg.msgfont = New Font(FonttoUse, FontStyle.Italic)

        Else
            formattedstring &= boldpref
            formattedstring &= Nick
            formattedstring &= ":  "
            formattedstring &= boldpost
            formattedstring &= Text
            newmsg.msgtxt &= Nick & ":  " & Text
            newmsg.msgfont = FonttoUse
        End If


        formattedstring &= "</font><br></div>"

        newmsg.formatmsgtxt = formattedstring
        Return newmsg


    End Function
    Private Function FormatText(ByVal OText As String, ByVal AdjText As String, ByVal Nick As String, ByVal FonttoUse As Font, ByVal ColortoUse As Color, ByVal IsAction As Boolean) As HtmlMessage
        'format message text into HTML string for HTML window
        Dim formattedstring As String = ""
        Dim newmsg As New HtmlMessage
        Dim boldpref As String = ""
        Dim boldpost As String = ""
        If BoldNickTime Then
            boldpref = "<b>"
            boldpost = "</b>"
        End If

        formattedstring = "<div style='font-size: " & FonttoUse.Size & "pt;line-height: 12px;vertical-align: middle; padding-right: 10px;'>"
        formattedstring &= "<font face='" & FonttoUse.Name & "'"
        formattedstring &= " color='" & System.Drawing.ColorTranslator.ToHtml(ColortoUse) & "'"
        formattedstring &= ">"
        Dim clientdate As Date = Now - datediff
        If ShowTime Then
            newmsg.msgtxt &= "[" & FormatDateTime(clientdate, DateFormat.ShortTime) & "]  "
            formattedstring &= boldpref & "[" & FormatDateTime(clientdate, DateFormat.ShortTime) & "]  " & boldpost
        End If
        If IsAction Then
            formattedstring &= "<i> "
            formattedstring &= Nick
            formattedstring &= AdjText
            formattedstring &= "</i>"
            newmsg.msgtxt &= Nick & OText
            newmsg.msgfont = FonttoUse
            newmsg.msgfont = New Font(FonttoUse, FontStyle.Italic)

        Else
            formattedstring &= boldpref
            formattedstring &= Nick
            formattedstring &= ":  "
            formattedstring &= boldpost
            formattedstring &= AdjText
            newmsg.msgtxt &= Nick & ":  " & OText
            newmsg.msgfont = FonttoUse
        End If

        'formattedstring &= "</font><br></div></tr>"
        formattedstring &= "</font><br></div>"
        newmsg.formatmsgtxt = formattedstring
        Return newmsg


    End Function
    Private Function FormatMessage(ByVal Channel As ChatChannel, ByVal Person As IrcUser, ByVal text As String) As HtmlMessage
        Dim formattedstring As String = ""
        Dim fonttouse As Font
        Dim colortouse As Color
        Dim adjustedbody As String
        Dim isaction As Boolean
        Dim newmsg As New HtmlMessage
        Dim omsg As String = text
        Dim ChanUser As IrcChannelUser

        adjustedbody = Regex.Replace(text, "<", "&lt;")
        adjustedbody = Regex.Replace(adjustedbody, ">", "&gt;")

        'adjustedbody = AddLinks(adjustedbody)
        'adjustedbody = AddSmileys(adjustedbody)



        If text.IndexOf(Chr(1)) <> -1 Then
            If text.IndexOf("ACTION") <> -1 Then
                'is action, treat differently than normal text
                adjustedbody = Regex.Replace(adjustedbody, Chr(1) & "ACTION", "")
                adjustedbody = Regex.Replace(adjustedbody, Chr(1), "")
                omsg = Regex.Replace(omsg, Chr(1) & "ACTION", "")
                omsg = Regex.Replace(omsg, Chr(1), "")
                fonttouse = NormtxtFont
                colortouse = Actiontxtcolor
                isaction = True
            End If
        Else
            If Channel.ChannelName.IndexOf("#") = -1 Then
                'PM
                fonttouse = NormtxtFont
                colortouse = NormTxtColor
            Else
                ChanUser = Channel.Channel.GetChannelUser(Person)
                If ChanUser.Modes.Contains("~") Or ChanUser.Modes.Contains("q") Then
                    fonttouse = COtxtFont
                    colortouse = COTxtColor
                ElseIf ChanUser.Modes.Contains("h") Then
                    fonttouse = HOTxtFont
                    colortouse = HOTxtColor
                ElseIf ChanUser.Modes.Contains("o") Then
                    fonttouse = OptxtFont
                    colortouse = OpTxtColor
                Else
                    fonttouse = NormtxtFont
                    colortouse = NormTxtColor
                End If
            End If


            isaction = False
        End If
        newmsg = FormatText(omsg, adjustedbody, Person.NickName, fonttouse, colortouse, isaction)

        Return newmsg

    End Function
#Region "HelperFunctions"
    Public Function RandomNumber(ByVal MaxNumber As Integer, _
    Optional ByVal MinNumber As Integer = 0) As Integer

        'initialize random number generator
        Dim r As New Random(System.DateTime.Now.Millisecond)

        'if passed incorrect arguments, swap them
        'can also throw exception or return 0

        If MinNumber > MaxNumber Then
            Dim t As Integer = MinNumber
            MinNumber = MaxNumber
            MaxNumber = t
        End If

        Return r.Next(MinNumber, MaxNumber)

    End Function
#End Region
End Class
